/* 公用函数
 * 
 * 
 * */

(function($, app) {
	var rem;
	var imageHost = 'http://www.765mall.com/uploads/';
	var HOST = 'http://app.765mall.com/v1x33/';
	var WWW_HOST = 'http://www.765mall.com/';
	var SHOP_HOST = 'http://shop.765mall.com/';
	var WEIXIN_HOST = 'http://app.765mall.com/';
	app.chatAppId = 'CTX9H7hNeFE4feOtKoacQjbC-gzGzoHsz'; //第三方(learnCloud)即时聊天AppID

	//初始化

	/**
	 * 初始化rem尺寸
	 */
	(function() {
		var oHtml = document.documentElement;
		// 获取屏幕的宽度
		var screenWidth = oHtml.clientWidth;
		rem = screenWidth / 15;
		oHtml.style.fontSize = rem + 'px';

		//沉浸式状态顶栏动态修改顶部高度
		var immersed = 0;
		var element;
		var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
		if (ms && ms.length >= 3) { // 当前环境为沉浸式状态栏模式
			immersed = parseFloat(ms[2]); // 获取状态栏的高度
			element = document.getElementsByTagName('header')[0];
			if (element) {
				element.style.height = 44 + immersed + 'px';
				element.style.paddingTop = immersed + 'px';
			}
		}

		$.plusReady(function() {
			//	只支持竖屏显示
			plus.screen.lockOrientation("portrait-primary");

			//监听个推
			plus.push.addEventListener("click", function(msg) {
				//监听到点击事件后，将透传消息的内容发送到服务器端，分析其内容，以确定打开哪里
				app.callInterface(63, msg, function(res) {
					//打开对应的页面，页面地址是ajax获取到的
					if (res.status == 200) {
						mui.openWindow({
							id: res.data.id,
							url: res.data.url,
							extras: res.data.extras,
						});
					}
				}, '', function() {});
			}, false);
			// 监听在线消息事件
			plus.push.addEventListener("receive", function(msg) {
				//如果是ios
				if (mui.os.ios) {
					//是服务器来的消息，就创建本地消息
					if (msg.aps) {
						plus.push.createMessage(msg.content, msg.title, {
							title: msg.title
						});
						app.setMessageCount();
						app.setSystemMessage(true);
					} else {
						//ios端创建本地消息不进行操作 
					}
				}
				//否则就是安卓的系统
				else {
					//取得推送的消息后，创建一个本地消息，以便能够监控到用户的消息点击事件
					plus.push.createMessage(msg.content, msg.title, {
						title: msg.title
					});
					app.setMessageCount();
					app.setSystemMessage(true);
				}
			}, false);
		});
	}());

	//Webview相关操作

	/**
	 * 关闭webview窗口
	 */
	app.closeWebview = function(ws) {
		plus.webview.close(ws);
	};

	/**
	 * 根据ID获取webview
	 */
	app.getWebviewById = function(id) {
		return plus.webview.getWebviewById(id);
	};

	/**
	 * 获取当前webview
	 */
	app.getCurrentWebview = function() {
		return plus.webview.currentWebview();
	};

	//本地缓存数据管理

	/**
	 *  根据item获取数据
	 * 参数：{
	 * 	item
	 * }
	 */
	app.getStorage = function(item) {
		return plus.storage.getItem(item);
	};

	/**
	 * 根据item设置数据
	 * 参数：{
	 * 	item，//设置项
	 * 	value //值
	 * }
	 */
	app.setStorage = function(item, value) {
		return plus.storage.setItem(item, value);
	};

	/**
	 * 根据item删除数据
	 * 参数：{
	 * 	item
	 * }
	 */
	app.removeStorage = function(item) {
		return plus.storage.removeItem(item);
	};

	/**
	 * 清除所有缓存数据
	 */
	app.clearStorage = function() {
		plus.storage.clear();
	};

	//原生组件

	/**
	 * 显示自动消失的提示消息
	 * http://www.html5plus.org/doc/zh_cn/nativeui.html#plus.nativeUI.toast
	 */
	app.toast = function(msg, options) {
		plus.nativeUI.toast(msg, options);
	};

	/**
	 * 弹出系统确认对话框
	 * http://www.html5plus.org/doc/zh_cn/nativeui.html#plus.nativeUI.confirm
	 */
	app.confirm = function(msg, callback, title) {
		plus.nativeUI.confirm(msg, callback, title, ["确定", "取消"]);
	};

	/**
	 * 弹出系统选择按钮框
	 * http://www.html5plus.org/doc/zh_cn/nativeui.html#plus.nativeUI.actionSheet
	 */
	app.actionSheet = function(actionsheetStyle, callback) {
		plus.nativeUI.actionSheet(actionsheetStyle, callback);
	};

	//数据接口访问

	/**
	 * 获取图片HOST
	 */
	app.getImageHost = function() {
		return imageHost;
	};

	/**
	 * 获取HOST
	 */
	app.getHost = function() {
		return HOST;
	};
	/**
	 * 返回pc端以及微信端打开时候使用的host
	 */
	app.getWWWHost = function() {
		return WWW_HOST;
	};
	/**
	 * 返回商城host
	 */
	app.getShopHost = function() {
		return SHOP_HOST;
	};
	
	/**
	 * 获取微信端链接
	 */
	app.getWeixinHost = function(){
		return WEIXIN_HOST;
	}
	
	/**
	 * 获取接口地址
	 */
	app.getlink = function(type) {

		var LINK_SENDSMS = HOST + 'auth/verifycode'; //1、发送验证码到手机或邮箱
		var LINK_REG = HOST + 'auth/reg'; //2、用户注册
		var LINK_LOGIN = HOST + 'auth/login'; //3、手机号码或邮箱登陆
		var LINK_THREELOGIN = HOST + 'auth/threelogin'; //4、第三方登陆
		var LINK_SETPASSWORD = HOST + 'auth/setpassword'; //5、找回密码，设置密码
		var LINK_SETINFO = HOST + 'account/setinfo'; //6、我的，设置用户信息
		var LINK_GETINDEX = HOST + 'article/getindex'; //7、骑葩首页
		var LINK_GETCATEGORYS = HOST + 'article/getcategorys'; //8、获取骑葩分类
		var LINK_GETLIST = HOST + 'article/getlist'; //9、获取文章列表
		var LINK_GETDETAIL = HOST + 'article/getdetail'; //10、获取文章详情页
		var LINK_CLICKSTAR = HOST + 'article/clickstar'; //11、文章点赞
		var LINK_GETCOMMENTS = HOST + 'article/getcomments'; //12、获取留言
		var LINK_ADDCOMMENT = HOST + 'article/addcomment'; //13、添加文章留言
		var LINK_DELCOMMENT = HOST + 'article/delcomment'; //14、删除文章留言
		var LINK_INDEX = HOST + 'index/index'; //15、首页数据获取接口
		var LINK_CATEGORY = HOST + 'index/category'; //16、分类初始页
		var LINK_PLAYLIST = HOST + 'index/playlist'; //17、分类页中获取活动
		var LINK_PLAYDETAIL = HOST + 'index/playdetail'; //18、活动详情
		var LINK_PUBLISH = HOST + 'index/publish'; //19、发布活动
		var LINK_ALTERPLAY = HOST + 'index/alterPlay'; //20、修改活动
		var LINK_PLAYCOMMENT = HOST + 'play/addcomment'; //21、发布评论
		var LINK_COMMENTLIST = HOST + 'play/getcomments'; //22、评论列表
		var LINK_COMMENTDEL = HOST + 'index/commentDel'; //23、删除评论
		var LINK_MYPLAYLIST = HOST + 'account/playList'; //24、个人中心获取我的活动列表
		var LINK_PLAYJOINED = HOST + 'account/playJoined'; //25、我参加过的活动
		var LINK_PLAYJOIN = HOST + 'index/playJoin'; //26、活动参加
		var LINK_PLAYLAUD = HOST + 'index/playLaud'; //27、赞活动
		var LINK_PLAYLAUDED = HOST + 'account/playLauded'; //28、我赞过的活动
		var LINK_OPINION = HOST + 'account/opinion'; //29、意见反馈
		var LINK_POSITION = HOST + 'global/getallcitys'; //30、城市定位，选择
		var LINK_USERS_BY_USERNAMES = HOST + 'global/getusersbyusernames'; //31.获取用户信息
		var LINK_ADDROOM = HOST + 'play/addroom'; //32.加入聊天室
		var LINK_ADDROOMRECORD = HOST + 'play/addroomrecord'; //33.添加聊天内容
		var LINK_GETMYROOMS = HOST + 'play/getmyrooms'; //34.获取我加入的聊天室
		var LINK_SETROOMREAD = HOST + 'play/setroomread'; //35.设置此聊天室是否读过
		var LINK_EXITROOM = HOST + 'play/exitroom'; //36.退出聊天室
		var LINK_GETREPLYMECOMMENTS = HOST + 'article/getreplymecomments'; //37.获取回复我的评论
		var LINK_GETPROVINCES = HOST + 'global/getprovinces'; //38.获取所有省份
		var LINK_GETCITYS = HOST + 'global/getcitys'; //39.获取所在省份的城市
		var LINK_PLAYGETREPLYMECOMMENTS = HOST + 'play/getreplymecomments'; //40.获取回复我的评论
		var LINK_ADDPLAYCOMMENT = HOST + 'index/addcomment'; //41.添加活动留言
		var LINK_UPLOADIMG = HOST + 'appBase/upload'; //42.上传图片
		var LINK_CREATEPLAYROOM = HOST + 'play/createroom'; //43.创建活动聊天室
		var LINK_DROPPLAY = HOST + 'play/drop'; //44.退出活动
		var LINK_DELETEPLAY = HOST + 'play/delete'; //45.删除活动
		var LINK_PLAYJOINERS = HOST + 'play/joiners'; //46.活动清单
		var LINK_GETUSERINFO = HOST + 'account/getinfo'; //47.获取非登陆用户信息
		var LINK_UPDATEAPP = HOST + 'update/index'; //48.APP更新
		var LINK_CHECKINSTALLUSER = HOST + 'global/installuser'; //49.app安装用户检测
		var LINK_GETPLAYTPLLIST = HOST + 'play/getTplList'; //50.获取模板列表
		var LINK_GETPLAYTPLBYID = HOST + 'play/getTplById'; //51.根据模板id获取模板数据
		var LINK_GETADDRESS = HOST + 'index/getAddress'; //52.获取当前用户的收货地址信息
		var LINK_GETDEFAULTADDRESS = HOST + 'index/getDefaultAddress'; //53.获取当前用户的默认收货地址
		var LINK_GETDGOODSDETAIL = HOST + 'index/getGoodsDetail'; //54.获取指定商品的数据
		var LINK_GETUSERPOWER = HOST + 'account/appraisalUserPower'; //55.鉴定当前用户是否具有兑换当前奖品的权限
		var LINK_DELADDRESS = HOST + 'account/delAddress'; //56.删除地址
		var LINK_ADDADDRESS = HOST + 'account/addAddress'; //57.添加地址
		var LINK_ADDCONVERT = HOST + 'account/addConvertData'; //58.提交确认收货的数据
		var LINK_ALTERADDRESS = HOST + 'account/alterAddress'; //59.修改地址数据
		var LINK_UPDATEMESSAGERESULT = HOST + 'message/handleMessage'; //60.修改消息结果
		var LINK_SENDMESSAGEINFO = HOST + 'message/sendHandleMessage'; //61.发送消息
		var LINK_GETMYMESSAGE = HOST + 'message/gets'; //62.发送消息
		var LINK_ANALISYSHYALINE = HOST + 'push/analysisHyaline'; //63.分析透传消息内容
		var LINK_GETARTICLESOURCE = HOST + 'article/getSource'; //64.	获取文章来源
		var LINK_LOGINBYCODE = HOST + 'auth/loginByCode'; //65. 通过短信验证码登陆

		//一骑玩新版接口相关
		var LINK_GETPLAY = HOST + 'index/getPlay'; //66. 最新活动详情接口
		var LINK_PUBLISHPLAY = HOST + 'index/publishPlay'; //67.最新活动发布接口
		var LINK_SUBMITJOIN = HOST + 'mall/submitJoinMatch'; //68.活动报名接口
		var LINK_PLAYS = HOST + 'index/plays'; //69.分类页中获取活动列表
		var LINK_NEWPUBLISH = HOST + 'index/changePlay'; //70.最新修改活动发布接口
		var LINK_GETCATEGORY = HOST + 'index/getPlayCategory'; //71.获取活动分类
		var LINK_NEWGETPLAY = HOST + 'index/getChangePlay'; //72.最新修改活动时候获取活动内容的接口
		var LINK_COUPONLIST = HOST + 'shop/couponList'; //73、首页获取未使用的红包列表：

		var LINK_PLAYCATEGORYRANKING = HOST + 'play/category_ranking'; //74.获取分类排行

		//以下101以后的是商城的接口，从一开始
		var LINK_SHOPINDEX = HOST + 'shop/index'; //101.商城首页
		var LINK_SETGROUP = HOST + 'shop/setGroup'; //102.付款成功后设置团信息
		var LINK_GETGROUPINFO = HOST + 'shop/getGroupInfo'; //103.获取团信息
		var LINK_GETRECOMMENDGROUP = HOST + 'shop/getRecommendGroup'; //104.获取推荐团信息
		var LINK_COUPON = HOST + 'account/coupon'; //105.优惠券列表 
		var LINK_RETREATGOODS = HOST + 'account/retreatGoods'; //106.申请退换货

		var LINK_ORDERLIST = HOST + 'mall/orders'; //107.获取订单列表
		var LINK_GETORDER = HOST + 'mall/orderdetail'; //108.获取订单详情

		var LINK_GETEXPRESS = HOST + 'shop/express'; //109.获取订单的物流信息
		var LINK_ADDCONSULT = HOST + 'account/consult'; //110.提交商品咨询
		var LINK_GETCONSULT = HOST + 'account/getConsult'; //111.获取商品咨询
		var LINK_GETGOODSGROUP = HOST + 'shop/getGoodsGroup'; //112.获取商品推荐团信息

		var LINK_AFFIRMRECEIVED = HOST + 'mall/affirmReceived'; //113.确认收货
		var LINK_CANCELORDER = HOST + 'mall/cancelOrder'; //114.取消订单
		var LINK_CLASSIFY = HOST + 'shop/category'; //115.获取分类信息
		var LINK_CLASSIFY_PRODUCT = HOST + 'shop/categoryGoods'; //116.获取分类商品

		var LINK_CHECKRETREATGOODS = HOST + 'account/checkRetreatInfo'; //117.检测是否申请过售后

		var LINK_REMINDSENDGOODS = HOST + 'account/remindSendGoods'; //118.检测提醒发货

		var LINK_ISSHOW = HOST + 'index/show'; //是否显示相应的第三方的东西
		var LINK_GOODSGUESSLOVE = HOST + 'shop/guessgoods'; //饵货120
		var LINK_GOODSCATEGORYS = HOST + 'shop/categorys'; //121 分类 子分类
		var LINK_MESSAGEREPLY = HOST + 'shop/orderMessageReply'; //122 商品订单咨询获取
		var LINK_ADDORDERMESSAGE = HOST + 'shop/addOrderMessage'; //123 商品订单咨询

		var LINK_INSURANCE = HOST + 'shop/addSafeInfo'; //124 保单数据提交
		var LINK_INSURANCE_ADD = HOST + 'shop/getNewestSafeInfo'; //125 获取保单数据

		//0元购相关
		var LINK_ACTIVELIST = HOST + 'zero/activeList'; //201 0元购活动列表展示
		var LINK_REMINDME = HOST + 'zero/remindMe'; //202 设置"提醒我"和取消"提醒我"
		var LINK_SIGNUPNOW = HOST + 'zero/signupNow'; //203 "马上抢"--活动报名
		var LINK_ZEROGOODSDETAIL = HOST + 'zero/zeroGoodsDetail'; //204 0元购活动商品详情页数据
		var LINK_RECOMMEND = HOST + 'zero/recommend'; //205 0元购推荐商品接口
		var LINK_AUTHORITY = HOST + 'zero/authority'; //206 兑换鉴权接口
		var LINK_CONVERTZERO = HOST + 'zero/convertZero'; //207  兑换接口
		var LINK_ZERO_GETRANK = HOST + 'zero/rank'; //208 排名接口

		switch (type) {
			case 1:
				return LINK_SENDSMS;
			case 2:
				return LINK_REG;
			case 3:
				return LINK_LOGIN;
			case 4:
				return LINK_THREELOGIN;
			case 5:
				return LINK_SETPASSWORD;
			case 6:
				return LINK_SETINFO;
			case 7:
				return LINK_GETINDEX;
			case 8:
				return LINK_GETCATEGORYS;
			case 9:
				return LINK_GETLIST;
			case 10:
				return LINK_GETDETAIL;
			case 11:
				return LINK_CLICKSTAR;
			case 12:
				return LINK_GETCOMMENTS;
			case 13:
				return LINK_ADDCOMMENT;
			case 14:
				return LINK_DELCOMMENT;
			case 15:
				return LINK_INDEX;
			case 16:
				return LINK_CATEGORY;
			case 17:
				return LINK_PLAYLIST;
			case 18:
				return LINK_PLAYDETAIL;
			case 19:
				return LINK_PUBLISH;
			case 20:
				return LINK_ALTERPLAY;
			case 21:
				return LINK_PLAYCOMMENT;
			case 22:
				return LINK_COMMENTLIST;
			case 23:
				return LINK_COMMENTDEL;
			case 24:
				return LINK_MYPLAYLIST;
			case 25:
				return LINK_PLAYJOINED;
			case 26:
				return LINK_PLAYJOIN;
			case 27:
				return LINK_PLAYLAUD;
			case 28:
				return LINK_PLAYLAUDED;
			case 29:
				return LINK_OPINION;
			case 30:
				return LINK_POSITION;
			case 31:
				return LINK_USERS_BY_USERNAMES;
			case 32:
				return LINK_ADDROOM;
			case 33:
				return LINK_ADDROOMRECORD;
			case 34:
				return LINK_GETMYROOMS;
			case 35:
				return LINK_SETROOMREAD;
			case 36:
				return LINK_EXITROOM;
			case 37:
				return LINK_GETREPLYMECOMMENTS;
			case 38:
				return LINK_GETPROVINCES;
			case 39:
				return LINK_GETCITYS;
			case 40:
				return LINK_PLAYGETREPLYMECOMMENTS;
			case 41:
				return LINK_ADDPLAYCOMMENT;
			case 42:
				return LINK_UPLOADIMG;
			case 43:
				return LINK_CREATEPLAYROOM;
			case 44:
				return LINK_DROPPLAY;
			case 45:
				return LINK_DELETEPLAY;
			case 46:
				return LINK_PLAYJOINERS;
			case 47:
				return LINK_GETUSERINFO;
			case 48:
				return LINK_UPDATEAPP;
			case 49:
				return LINK_CHECKINSTALLUSER;
			case 50:
				return LINK_GETPLAYTPLLIST;
			case 51:
				return LINK_GETPLAYTPLBYID;
			case 52:
				return LINK_GETADDRESS;
			case 53:
				return LINK_GETDEFAULTADDRESS;
			case 54:
				return LINK_GETDGOODSDETAIL;
			case 55:
				return LINK_GETUSERPOWER;
			case 56:
				return LINK_DELADDRESS;
			case 57:
				return LINK_ADDADDRESS;
			case 58:
				return LINK_ADDCONVERT;
			case 59:
				return LINK_ALTERADDRESS;
			case 60:
				return LINK_UPDATEMESSAGERESULT;
			case 61:
				return LINK_SENDMESSAGEINFO;
			case 62:
				return LINK_GETMYMESSAGE;
			case 63:
				return LINK_ANALISYSHYALINE;
			case 64:
				return LINK_GETARTICLESOURCE;
			case 65:
				return LINK_LOGINBYCODE;
			case 66:
				return LINK_GETPLAY;
			case 67:
				return LINK_PUBLISHPLAY;
			case 68:
				return LINK_SUBMITJOIN;
			case 69:
				return LINK_PLAYS;
			case 70:
				return LINK_NEWPUBLISH;
			case 71:
				return LINK_GETCATEGORY;
			case 72:
				return LINK_NEWGETPLAY;
			case 73:
				return LINK_COUPONLIST;
			case 74:
				return LINK_PLAYCATEGORYRANKING;

			case 101:
				return LINK_SHOPINDEX;
			case 102:
				return LINK_SETGROUP;
			case 103:
				return LINK_GETGROUPINFO;
			case 104:
				return LINK_GETRECOMMENDGROUP;
			case 105:
				return LINK_COUPON;
			case 106:
				return LINK_RETREATGOODS;
			case 107:
				return LINK_ORDERLIST;
			case 108:
				return LINK_GETORDER;
			case 109:
				return LINK_GETEXPRESS;
			case 110:
				return LINK_ADDCONSULT;
			case 111:
				return LINK_GETCONSULT;
			case 112:
				return LINK_GETGOODSGROUP;
			case 113:
				return LINK_AFFIRMRECEIVED;
			case 114:
				return LINK_CANCELORDER;
			case 115:
				return LINK_CLASSIFY;
			case 116:
				return LINK_CLASSIFY_PRODUCT;
			case 117:
				return LINK_CHECKRETREATGOODS;
			case 118:
				return LINK_REMINDSENDGOODS;
			case 119:
				return LINK_ISSHOW;
			case 120:
				return LINK_GOODSGUESSLOVE;
			case 121:
				return LINK_GOODSCATEGORYS;
			case 122:
				return LINK_MESSAGEREPLY;
			case 123:
				return LINK_ADDORDERMESSAGE;
			case 124:
				return LINK_INSURANCE;
			case 125:
				return LINK_INSURANCE_ADD;

			case 201:
				return LINK_ACTIVELIST;
			case 202:
				return LINK_REMINDME;
			case 203:
				return LINK_SIGNUPNOW;
			case 204:
				return LINK_ZEROGOODSDETAIL;
			case 205:
				return LINK_RECOMMEND;
			case 206:
				return LINK_AUTHORITY;
			case 207:
				return LINK_CONVERTZERO;
			case 208:
				return LINK_ZERO_GETRANK;
		}
	};

	/**
	 * 调用接口
	 */
	app.callInterface = function(number, data, callback, type, errcallback) {
		app.ajax({
			url: app.getlink(number),
			callback: callback,
			data: data,
			type: type ? 'get' : 'post',
			errcallback: errcallback
		});
	};

	//公用方法

	/*
	 * ajax 操作方法
	 * 参数：{
	 * 	url, // 地址
	 *  data, //发送参数（可为空）
	 * 	callback //回调方法
	 * }
	 * */
	app.ajax = function(oAjax) {
		if (oAjax && oAjax.url && oAjax.callback) {
			$.ajax({
				type: oAjax.type,
				dataType: "json",
				timeout: 6000,
				contentType: "application/x-www-form-urlencoded; charset=utf-8",
				url: oAjax.url,
				data: oAjax.data,
				success: oAjax.callback,
				error: oAjax.errcallback ? oAjax.errcallback : function(jqXHR, textStatus, errorThrown) {
					plus.nativeUI.closeWaiting();
					app.toast('网络连接失败，请重新尝试一下')
				}
			});
		}
	};

	/**
	 * json继承
	 */
	app.extend_json = function(des, src, override) {
		if (src instanceof Array) {
			for (var i = 0, len = src.length; i < len; i++)
				extend(des, src[i], override);
		}
		for (var i in src) {
			if (override || !(i in des)) {
				des[i] = src[i];
			}
		}
		return des;
	}

	/**
	 * 获取当前基础rem值
	 */
	app.getRem = function() {
		return rem;
	};

	app.hasClass = function(obj, cls) {
		return obj.className.match(new RegExp('(\\s|^)' + cls + '(\\s|$)'));
	};

	app.addClass = function(obj, cls) {
		if (!this.hasClass(obj, cls)) obj.className += " " + cls;
	};

	app.removeClass = function(obj, cls) {
			if (app.hasClass(obj, cls)) {
				var reg = new RegExp('(\\s|^)' + cls + '(\\s|$)');
				obj.className = obj.className.replace(reg, ' ');
			}
		}
		//---------------------------------分享部分-----------------------------
	app.share = {};
	app.shareInit = function() {

		plus.share.getServices(function(s) {
			if (s && s.length > 0) {
				for (var i = 0; i < s.length; i++) {
					var t = s[i];
					app.share[t.id] = t;
				}
				app.cancelAuth(); //清理授权
			}
		}, function() {
			console.log("获取分享服务列表失败");
		});
	};
	/**
	 * 调用app.shareClick()前调用此方法，配置分享出去的title、url以及简介内容
	 * @param {Object} title
	 * @param {Object} URL
	 * @param {Object} content
	 * @param {Object} cutImgDom  要生成截图的dom结构的标记（可以是class和id）
	 * 							  class时格式为".className",id时是"#idName"
	 * @param {Object} QRCodeImg  要生成截图的dom结构中的二维码图片的标记（可以是class和id）
	 * 							  class时格式为".className",id时是"#idName"
	 */
	app.shareConfig = function(title, URL, content, cutImgDom, QRCodeImg, thumbs, picture) {
		app.shareTitle = title;
		app.shareUrl = URL;
		app.shareContent = content;
		app.shareThumbs = (thumbs != undefined && thumbs != null && thumbs != '') ? thumbs : "_www/images/logo.png";
		app.sharePicture = (picture != undefined && picture != null && picture != '') ? picture : "_www/images/logo.png";
		app.cutImgDom = (cutImgDom != undefined && cutImgDom != null && cutImgDom != '') ? cutImgDom : '#htmlToImgDom'; //需要生成截图的dom
		app.QRCodeImg = (QRCodeImg != undefined && QRCodeImg != null && QRCodeImg != '') ? QRCodeImg : '#QRCode'; //为点击生成的截图中加二维码
		return;
	};
	app.shareMessage = function(share, ex) {
		var msg = {
			extra: {
				scene: ex
			}
		};
		msg.href = app.shareUrl;
		msg.title = app.shareTitle;
		msg.content = app.shareContent;
		//		if (~share.id.indexOf('weibo')) {
		//			msg.content += "；体验地址：http://www.dcloud.io/hellomui/";
		//		}
		msg.thumbs = [app.shareThumbs];
		if (ex != 'sinaweibo') {
			msg.pictures = [app.sharePicture];
		}
		share.send(msg, function() {
			app.toast("分享成功");
			console.log("分享到\"" + share.description + "\"成功！ ");
		}, function(e) {
			console.log("分享到\"" + share.description + "\"失败: " + e.code + " - " + e.message);
			if (e.code == -8) {
				app.toast('抱歉,您尚未安装' + share.description);
			}
		});
	};
	/**
	 * 点击分享事件
	 */
	app.shareAfterClick = function(title, URL, content, cutImgDom, QRCodeImg, thumbs, picture) {
		app.shareInit();
		app.shareConfig(title, URL, content, cutImgDom, QRCodeImg, thumbs, picture);
		var ids = [],
			bts = [];
		var isShow = app.getStorage('oAuthIsShow');
		//如果是ios微博分享去除
		if (plus.os.name != 'iOS') {
			ids.push({
				id: "sinaweibo",
				ex: "sinaweibo"
			});
			bts.push({
				title: "分享到新浪微博"
			});
		}
		if (isShow === '1') {
			//增加微信
			ids.push({
				id: "weixin",
				ex: "WXSceneSession"
			});
			ids.push({
				id: "weixin",
				ex: "WXSceneTimeline"
			});
			bts.push({
				title: "发送给微信好友"
			});
			bts.push({
				title: "分享到微信朋友圈"
			});
			//增加qq
			ids.push({
				id: "qq",
				ex: "qq"
			});
			bts.push({
				title: "分享到QQ"
			});
		}
		plus.nativeUI.actionSheet({
			cancel: "取消",
			buttons: bts
		}, function(e) {
			var i = e.index;
			//生成图片
			if (i == 5) {
				//将页面中的几个图标隐藏掉
				document.querySelector('footer').style.display = 'none';
				document.querySelector(app.cutImgDom + ' ' + app.QRCodeImg).style.display = 'inline-block';
				app.saveHtmlToimage(app.cutImgDom, function() {
					//将页面中的几个图标取消隐藏
					document.querySelector('footer').style.display = 'block';
					document.querySelector(app.cutImgDom + ' ' + app.QRCodeImg).style.display = 'none';
				});
				return;
			}
			if (i > 0 && i < 5) {
				var s_id = ids[i - 1].id;
				var share = app.share[s_id];
				if (share.authenticated) {
					app.shareMessage(share, ids[i - 1].ex);
				} else {
					share.authorize(function() {
						app.shareMessage(share, ids[i - 1].ex);
					}, function(e) {
						console.log("认证授权失败：" + e.code + " - " + e.message);
						if (e.code == -8) {
							app.toast('抱歉,您尚未安装' + share.description);
						}
					});
				}
			}
		});
		return;
	};
	/**
	 * 解除所有分享服务的授权
	 */
	app.cancelAuth = function() {
		var ids = [{
			id: "weixin",
			ex: "WXSceneSession"
		}, {
			id: "weixin",
			ex: "WXSceneTimeline"
		}, {
			id: "sinaweibo"
		}, {
			id: "qq"
		}];
		for (var i in ids) {
			var s = app.share[ids[i].id];
			if (s.authenticated) {
				console.log("取消\"" + s.description + "\"");
			}
			s.forbid();
		}
		// 取消授权后需要更新服务列表
		app.updateSerivces();
	};
	/**
	 * 更新分享服务
	 */
	app.updateSerivces = function() {
		plus.share.getServices(function(s) {
			for (var i in s) {
				var t = s[i];
				app.share[t.id] = t;
			}
		}, function(e) {
			console.log("获取分享服务列表失败：" + e.message);
		});
	};
	app.waitingObj;
	/**
	 * 将base64的图片保存到本地相册中
	 * @param {Object} base64   图片的base64编码
	 */
	app.saveBase64ToGallery = function(base64, successCallback) {
			var bitmap = new plus.nativeObj.Bitmap("bitmap");
			bitmap.loadBase64Data(base64, function() {
				var savaPath = '_doc/' + Date.parse(new Date()) + '.jpg';
				bitmap.save(savaPath, {}, function(i) {
					successCallback();
					//将图片存到相册中
					plus.gallery.save(savaPath, function() {
						app.waitingObj.close();
						app.delTempImage(savaPath);
						app.toast('图片已保存到您的本地相册中！');
					}, function() {
						console.log('保存到相册失败');
					});
				}, function(e) {});
			}, function(e) {});
		}
		/**
		 * 将完整页面存为图片
		 */
	app.saveHtmlToimage = function(domName, successCallback) {
		app.waitingObj = plus.nativeUI.showWaiting("处理中，请等待...");
		html2canvas(document.querySelector(domName), {
			allowTaint: true,
			taintTest: false,
			onrendered: function(canvas) {
				setTimeout(function() {
					canvas.id = "mycanvas";
					app.saveBase64ToGallery(canvas.toDataURL(), successCallback);
				}, 2000);
			}
		});
	}

	//--------------------------图片上传部分----------------------------
	/**
	 * 图片上传
	 * @param {Object} path  	选择后的图片地址
	 * @param {Object} zipData  压缩参数{quality,width}质量(没有就使用50)和宽度，均为可选
	 */
	app.upload = function(path, zipData, uploadSuccessCall, uploadErrorCall) {
			//app.uploader(path);return false;
			plus.io.resolveLocalFileSystemURL(path, function(entry) {
				entry.file(function(file) {
					//imageZiped是压缩后的图片地址
					var imageZiped = app.imageZip(path, zipData, function(event) {
						//这里加一个延时是为了避免压缩的时候未完成就调用，这样会造成失败
						setTimeout(function() {
							//压缩完成后将图片解析为base64编码
							var bitmap = new plus.nativeObj.Bitmap("");
							bitmap.load(imageZiped, function() {
								var base64 = bitmap.toBase64Data();
								//判断base64的字符串长度，如果过长，就进行分段上传
								var size = 1000 * 1024;
								var isEnd = false;
								var num = Math.ceil(base64.length / size); //需要循环的次数,即base64分成几段
								//return false;
								var uploadObj = {};
								uploadObj.currentIndex = 0;
								uploadObj.successCall = function(res) {
									uploadObj.currentIndex++;
									uploadSuccessCall(res);
									uploadObj.doUpload();
								}
								uploadObj.doUpload = function() {
										if (uploadObj.currentIndex >= num) {
											return;
										}
										if ((uploadObj.currentIndex + 1) == num) {
											isEnd = true;
										}
										var i = uploadObj.currentIndex;
										app.postBase64(base64.substr(size * i, size), isEnd, uploadObj.successCall, uploadErrorCall, i);
									}
									//执行ajax进行上传[使用递归方式循环调用，否则会出问题]
								uploadObj.doUpload();
							}, function(e) {
								mui.toast('加载图片失败：' + JSON.stringify(e));
							});
						}, 100);
					}, function(error) {
						mui.toast(error);
					});
				})
			}, function(e) {
				mui.toast('错误信息：' + e.message);
			});
		}
		/**
		 * 
		 * @param {Object} str					要上传的base64字符串
		 * @param {Object} isEnd				是否结束啦，bool值.true表示本次是最后一次，否则就不是
		 * @param {Object} uploadSuccessCall	上传成功执行的方法
		 * @param {Object} uploadErrorCall		上传失败执行的方法
		 */
	app.postBase64 = function(str, isEnd, uploadSuccessCall, uploadErrorCall, orderNumber) {
			//将token传递上去，是为了识别唯一用户，而非鉴权
			var data = {
				img: str,
				token: app.getStorage('token'),
				orderNumber: orderNumber
			};
			if (isEnd) {
				data.end = 1;
			} else {
				data.end = 0;
				//如果没有结束，就将成功以及失败方法从重写为空方法
				//				uploadSuccessCall = function() {};
				//				uploadErrorCall = function() {};
			}
			app.callInterface(42, data, uploadSuccessCall, '', uploadErrorCall);
		}
		/**
		 * 图片压缩
		 * @param {Object} imagePath  		要压缩的图片的原地址
		 * @param {Object} zipData    		压缩图片的参数
		 * @param {Object} successCallback  成功后的回调函数
		 * @param {Object} errorCallback    失败后的回调函数
		 */
	app.imageZip = function(imagePath, zipData, successCallback, errorCallback) {
			var random = String(Math.random()).replace('0.', '');
			var zipParam = {};
			zipParam.src = imagePath;
			zipParam.dst = '_doc/' + random + '.jpg'; //此处文件名要随机生成
			zipParam.format = 'jpg'; //图片全部统一为jpg格式
			//如果有quality参数，就进行质量压缩，quality从1-100
			if (zipData.quality && zipData.quality <= 100 && zipData.quality >= 1) {
				zipParam.quality = zipData.quality;
			} else {
				zipParam.quality = 100;
			}
			if (zipData.width) {
				zipParam.width = zipData.width;
			}
			plus.zip.compressImage(zipParam, successCallback, errorCallback);
			return zipParam.dst;
		}
		/**
		 * 删除单张临时图片
		 * @param {Object} image
		 */
	app.delTempImage = function(image) {
			plus.io.resolveLocalFileSystemURL(image, function(entry) {
				entry.remove(function() {}, function() {});
			}, function() {});
		}
		/**
		 * 删除临时存储的图片
		 * @param {Object} imageArr
		 */
	app.delTempImages = function(imageArr) {
		for (var i in imageArr) {
			//执行删除临时文件操作
			app.delTempImage(imageArr[i]);
		}
	}

	/**
	 * 图片的上传功能
	 */
	app.uploader = function(path) {
		//	app.uploader = function(path,uploadSuccessCall,uploadErrorCall){
		var server = HOST + "index/uploadPic";
		var files = [];
		files.push({
			name: "uploadkey",
			path: path
		});
		// 上传文件
		//		function upload(){
		if (files.length <= 0) {
			plus.nativeUI.alert("没有添加上传文件！");
			return;
		}
		var wt = plus.nativeUI.showWaiting();
		var task = plus.uploader.createUpload(server, {
				method: "POST"
			},
			function(t, status) { //上传完成
				if (status == 200) {
					plus.storage.setItem("uploader", t.responseText);
					wt.close();
				} else {
					wt.close();
				}
				console.log(status);
			}
		);
		task.addData("client", "HelloH5+");
		task.addData("uid", '11111');
		for (var i = 0; i < files.length; i++) {
			var f = files[i];
			task.addFile(f.path, {
				key: f.name
			});
		}
		task.start();
		//		}
	}

	/**
	 * 创建活动聊天室
	 * @param playId 活动ID
	 * @param callback 创建成功后回调
	 */
	app.createPlayRoom = function(playId, callback) {
		var loginUser = JSON.parse(app.getStorage('user')); //登陆者信息
		var clientId = loginUser.username; //登陆者用户名
		//创建实时通信实例(基于创建者)
		var rt = AV.realtime({
			appId: app.chatAppId,
			clientId: clientId,
			secure: false
		});

		rt.on('open', function() {
			console.log('服务器连接成功！');
			// 创建一个新 room
			rt.room({
				name: '活动' + playId, // Room 的默认名字
				members: [clientId], // 默认成员的 clientId
				attr: {
					playId: playId
				} //增加一些属性
			}, function(obj) {
				// 创建成功，后续你可以将 room id 存储起来
				var roomId = obj.id;
				console.log('创建一个新 Room 成功，id 是：', roomId);
				app.callInterface(43, {
					playid: playId,
					roomid: roomId
				}, function(res) {
					console.log(JSON.stringify(res));
					var chatobj = plus.webview.getWebviewById('_www/views/chat/index.html');
					if (chatobj) {
						chatobj.close();
					}
					callback();
				});
				// 关闭原连接，重新开启新连接
				rt.close();
			});
		});
	}

	/**
	 * 打开活动聊天时页面
	 * @param playId 活动ID
	 */
	app.openPlayRoom = function(playId) {
		if (app.isLogin() == false) {
			app.openLogin();
			return;
		}
		var ws = plus.webview.create('_www/views/chat/play.html', null, null, {
			play_id: playId
		});
		ws.addEventListener('loaded', function() {
			ws.show('pop-in');
		});
	}

	/**
	 * 打开活动详情页
	 * @param    play_id 		int		 活动id
	 */
	app.openPlayDetail = function(play_id) {
			mui.openWindow({
				url: '_www/views/template_detail/new_detail.html',
				createNew: true, //有重复页面重新加载打开
				extras: {
					play_id: play_id
				},
				waiting: {
					autoShow: false
				}
			});
		}
		/**
		 * 打开发布页面
		 * @param 	 category_id 	 int 	 活动分类id
		 * @param 	 play_id 	     int 	 活动id 有表示编辑
		 */
	app.openPlayPublish = function(play_id) {
		var url = '_www/views/template_publish/new_publish.html';
		mui.openWindow({
			url: url,
			extras: {
				playId: play_id
			}
		});
	};

	//打开外部链接
	app.openBrowser = function(href) {
			mui.openWindow({
				url: '_www/views/browser.html',
				extras: {
					href: href
				},
				waiting: {
					autoShow: false
				}
			});
	};
		

	//打开登陆页面
	app.openLogin = function() {
		mui.openWindow({
			url: '_www/views/my/my_login.html'
		});
	};

	//检测是否登陆
	app.isLogin = function() {
		var token = app.getStorage('token');
		var isLogin = false;
		if (!(token == undefined || token == null || token == '')) {
			isLogin = true;
		}
		return isLogin;
	};

	//监听消息
	app.getMessageCount = function() {
		var count = app.getStorage('messageCount');
		if (count == null || count == undefined) {
			count = '0';
			app.setStorage('messageCount', count);
		}
		count = parseInt(count);
		if (isNaN(count)) {
			count = 0;
		}
		//console.log(plus.webview.currentWebview().id+':getMessageCount:'+count);
		return count;
	}
	app.setMessageCount = function() {
		var count = app.getMessageCount() + 1;
		app.setStorage('messageCount', count.toString());
		//console.log('setMessageCount:'+count);
	}

	app.getSystemMessage = function() {
		var has = app.getStorage('hasSystemMessage');
		if (has == undefined || has == null || has == '') {
			return false;
		}
		return true;
	}

	app.setSystemMessage = function(flag) {
		if (flag) {
			flag = 'has system message';
		} else {
			flag = '';
		}
		app.setStorage('hasSystemMessage', flag);
	}

	app.monitorMessage = function() {
		try {
			if (app.isLogin() == false) {
				return;
			}
			var loginUser = JSON.parse(app.getStorage('user')); //登陆者信息
			var clientId = loginUser.username; //登陆者用户名
			//创建实时通信实例(基于创建者)
			var rt = AV.realtime({
				appId: app.chatAppId,
				clientId: clientId,
				secure: false
			});

			// 监听所有 Conversation 中发送的消息
			rt.on('message', function(data) {
				//console.log(JSON.stringify(data));
				var from = data.fromPeerId;

				//不是来自自己
				if (from !== clientId) {

					//只监测首页
					if (plus.webview.getLaunchWebview().id == plus.webview.currentWebview().id) {
						var isPush = app.playIsReceive(data.msg.playid);
						if (isPush) {
							//没有红点点时推送一次，防止不停的推送
							//if (!document.querySelector('.icon-message')) return;
							//if(document.querySelector('.icon-message').classList.contains('clearfix'))
							//{
							var pushinfo = {
								mode: 'single',
								os: plus.os.name,
								title: '骑乐无穷-活动群来消息了',
								text: data.msg.nickname + '：' + data.msg.text,
								cid: plus.push.getClientInfo().clientid,
								token: plus.push.getClientInfo().token,
							};
							//}
							app.getui(pushinfo);
						}
					}

					app.setMessageCount();
				}

			});

			setInterval(function() {
				if (!document.querySelector('.icon-message')) return;
				if (app.getMessageCount() > 0) {
					document.querySelector('.icon-message').classList.remove('clearfix');
				} else {
					document.querySelector('.icon-message').classList.add('clearfix');
				}
			}, 1000);

		} catch (e) {
			//TODO handle the exception
		}
	}

	/**
	 * 验证当前用户是否验证过手机，如果没有验证过，那就跳转到手机验证页面
	 * @param {Object} isGo				bool	  是否要跳到验证页面
	 * @param {Object} categoryId		bool	  是否要跳到验证页面
	 * @return 		 					bool	 true：验证过了；false：没有验证过
	 */
	app.isVerifyPhone = function(isGo, categoryId) {
			isGo = isGo ? true : false;
			var from = categoryId ? 'publish' : 'join';
			//如果没有绑定手机，先跳到手机验证页面
			if (!JSON.parse(app.getStorage('user')).phone) {
				if (!isGo) {
					var extras = {
						from: from
					};
					if (from == 'publish') {
						extras.category_id = categoryId;
					}
					mui.openWindow({
						id: 'check_phone.html',
						url: '_www/views/my/check_phone.html',
						extras: extras
					});
				}
				return false;
			}
			return true;
		}
		/**
		 * 设置二维码图片的链接
		 * @param {Object} imgId 	存二维码的图片的id
		 * @param {Object} url  	要生成二维码的链接，其中不能含有&，即此url只能传递一个参数。
		 * 							如  http://www.765mall.com/weixin/play/share?id=157       ok
		 * 							   http://www.765mall.com/weixin/play/share?id=157&p=1   error 
		 */
	app.setQRCode = function(imgId, url) {
		url = 'http://s.jiathis.com/qrcode.php?url=' + url;
		document.querySelector('#' + imgId).setAttribute('src', url);
	}

	//打开非登陆用户信息
	app.openUserInfo = function(uid) {
		var currentUser = JSON.parse(app.getStorage('user'));
		if (uid == currentUser.id || uid == currentUser.username) {
			mui.openWindow({
				url: '_www/views/my/my_show.html',
				id: 'my_show.html',
				extras: {
					uid: uid,
					isMy: true
				}
			});
		} else if (uid) {
			mui.openWindow({
				url: '_www/views/my/my_show.html',
				id: 'my_show.html',
				extras: {
					uid: uid,
					isMy: false
				}
			});
		}
	}

	//查看地图
	app.openMap = function(province, city, address) {
		var href = 'http://www.765mall.com/qqmap.php?province=' + province + '&city=' + city + '&address=' + address;
		var href = encodeURI(href);
		app.openBrowser(href);
	}

	//	修改图片
	app.changePic = function() {
		var that = this;
		if (that == mui('.placeholder')[0]) {
			that = mui('body')[0]
		}
		// 从相册中选择图片
		console.log("从相册中选择图片:");
		plus.gallery.pick(function(path) {
			plus.nativeUI.showWaiting()
			app.upload(path, {}, function(res) {
				if (res.status == 200) {
					that.setAttribute('imgSrc', res.data.pic);
					that.style.backgroundImage = "url(" + app.getImageHost() + res.data.pic + ")";
					plus.nativeUI.closeWaiting();
					return;
					bitmap = new plus.nativeObj.Bitmap("test");
					// 从本地加载Bitmap图片
					bitmap.load(path, function() {
						var base64 = bitmap.toBase64Data();
						that.style.backgroundImage = "url(" + base64 + ")";
						plus.nativeUI.closeWaiting()
					}, function(e) {
						console.log('加载图片失败：' + JSON.stringify(e));
						plus.nativeUI.closeWaiting()
					});
				} else {
					plus.nativeUI.alert(res.info);
					plus.nativeUI.closeWaiting()
				}
			}, function() {
				plus.nativeUI.alert('您的网络出现问题，请检查网络');
				plus.nativeUI.closeWaiting()
			})
		}, function(e) {
			console.log("取消选择图片");
			if (e.code == 8) {
				app.toast('请启用选择图片的权限');
			}
		}, {
			filter: "image"
		});
	}

	//个推
	app.getui = function(data) {
		app.ajax({
			url: 'http://www.765mall.com/getui/push.php',
			data: data,
			type: 'post',
			callback: function(res) {
				console.log(JSON.stringify(res));
			},
			errcallback: function() {

			}
		});
	}

	//监听页面back方法，更新个人中心活动列表
	app.reloadMyBack = function() {
		var oldBack = mui.back,
			myWebview;
		//如果个人中心页面已打开
		if (myWebview = plus.webview.getWebviewById('my.html')) {
			mui.back = function() {
				mui.fire(myWebview, 'reload', {});
				oldBack();
			};
		}
	}

	app.parseURL = function(url) {
		var a = document.createElement('a');
		a.href = url;
		return {
			source: url,
			protocol: a.protocol.replace(':', ''),
			host: a.hostname,
			port: a.port,
			query: a.search,
			params: (function() {
				var ret = {},
					seg = a.search.replace(/^\?/, '').split('&'),
					len = seg.length,
					i = 0,
					s;
				for (; i < len; i++) {
					if (!seg[i]) {
						continue;
					}
					s = seg[i].split('=');
					ret[s[0]] = s[1];
				}
				return ret;
			})(),
			file: (a.pathname.match(/\/([^\/?#]+)$/i) || [, ''])[1],
			hash: a.hash.replace('#', ''),
			path: a.pathname.replace(/^([^\/])/, '/$1'),
			relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || [, ''])[1],
			segments: a.pathname.replace(/^\//, '').split('/')
		};
	}

	//判断活动是接收消息
	app.playIsReceive = function(playId) {
		var receive = true;
		if (playId) {
			var _t = app.getStorage('PlayPushReceive' + playId);
			if (_t && _t == 'no') {
				receive = false;
			}
		}
		return receive;
	}

	app.setPlayIsReceive = function(playId, flag) {
		app.setStorage('PlayPushReceive' + playId, flag);
	}

	//设置定位信息info:{province:省份,city:城市,district:区县,address:地址}
	app.setLocation = function(info) {
		var province = info.province;
		if (province) {
			province = province.replace('市', '').replace('省', '');
			app.setStorage('province', province);
		}
		var city = info.city;
		if (city) {
			city = city.replace('市', '');
			app.setStorage('city', city);
		}
		var district = info.district;
		if (district) {
			district = district.replace('区', '').replace('县', '');
			app.setStorage('district', district);
		}
		var address = info.address;
		if (address) {
			app.setStorage('address', address);
		}
	}

	//获取定位信息
	app.getLocation = function() {
		var info = {
			province: '',
			city: '',
			district: '',
			address: '',
		};

		var province = app.getStorage('province');
		if (province) {
			info.province = province;
		}

		var city = app.getStorage('city');
		if (city) {
			info.city = city;
		}

		var district = app.getStorage('district');
		if (district) {
			info.district = district;
		}

		var address = app.getStorage('address');
		if (address) {
			info.address = address;
		}

		return info;

	}

	app.getLoginInfo = function() {
		var userInfo = JSON.parse(app.getStorage('user'));
		if (userInfo == undefined || userInfo == null || userInfo == '' || userInfo == false || userInfo == 0) {
			userInfo = {};
		}
		return userInfo;
	}

	//设置发布页面footer position 防止ios软键盘弹出导致 flexd失效
	app.setFooterPosition = function() {
		var main = mui('.nt-footer')[0];
		var inputArr = mui('textarea');
		var spanArr = mui('.remark span')[0];

		mui.each(inputArr, function(index, element) {
			element.addEventListener('focus', function(e) {
				main.style.display = 'none';
				e.preventDefault();
			}, false);
			element.addEventListener('blur', function(e) {
				main.style.display = 'block';
			}, false);
		});
		spanArr.addEventListener('focus', function(e) {
			main.style.display = 'none';
			e.preventDefault();
		}, false);
		spanArr.addEventListener('blur', function(e) {
			main.style.display = 'block';
		}, false);
	};

	//支付渠道
	app.payChannels = {};

	//获取支付通道
	app.getPayChannels = function(callback) {
		var pays = {};
		plus.payment.getChannels(function(channels) {
			for (var i in channels) {
				var channel = channels[i];
				pays[channel.id] = channel;
			}
			var cmb = {
				id: 'cmb',
				description: '招行',
			};
			pays[cmb.id] = cmb;
			app.payChannels = pays;
			if (callback) {
				callback(pays);
			}
		});
	}

	/**
	 * 选择支付方式
	 * @param {Object} callBack   选择好支付方式后的回调方法
	 */
	app.choosePay = function(callBack) {
		var ids = ['alipay', 'wxpay', 'cmb'];
		var bts = [{
			title: "支付宝支付"
		}, {
			title: "微信支付"
		}, {
			title: "招行支付"
		}];
		if (app.getStorage('oAuthIsShow') == 0) {
			//若从缓存中取出的isshow为0，则表示不让显示第三方的，所以移除微信支付
			ids.splice(1, 1);
			bts.splice(1, 1);
		}
		plus.nativeUI.actionSheet({
			cancel: "取消",
			buttons: bts
		}, function(e) {
			var i = e.index;
			if (i > 0) {
				var pay_code = ids[i - 1];
				var title = bts[i - 1].title;
				callBack(title, pay_code);
			}
		});
	}

	//调出支付通道进行支付
	app.pay = function(payid, request_data, pay_success_callback) {
		//检测支付通道
		if (!(payid in app.payChannels)) {
			mui.alert('不支持此支付通道！');
			return;
		}

		var paytype = 0; //支付类型 0：提交新订单 1：支付已下的订单
		var request_url = app.getHost() + 'mall/submitOrder';
		if (request_data.order_id > 0) {
			paytype = 1;
			request_url = app.getHost() + 'mall/payOrder';
		}

		var order_id = 0;
		var token = app.getStorage('token'); //用户token

		plus.nativeUI.showWaiting();
		//获取调出支付通道的支付签名
		mui.getJSON(request_url, request_data, function(res) {
			plus.nativeUI.closeWaiting();
			//201表示支付成功且更改了支付状态（支付金额为0的情况下）,支付结束，无需调用支付接口
			if (res.status == 201) {
				if (pay_success_callback) {
					pay_success_callback(res.data);
				} else {
					mui.alert('支付成功');
				}
				return;
			}
			if (res.status == 200) {
				order_id = res.data.order_id;
				var sign = res.data.sign;
				//招行支付通道独立处理
				if (payid == 'cmb') {
					plus.nativeUI.showWaiting();
					//招行独立处理
					//创建招行支付WebView
					var ws = plus.webview.create(sign);
					ws.addEventListener('loaded', function() {
						ws.evalJS("plus.key.addEventListener('backbutton',function(){plus.webview.currentWebview().opener().evalJS('cmbMerchantRetClick()');plus.webview.currentWebview().close();},false);");
						plus.nativeUI.closeWaiting();
						ws.show();
					});

					//监听招行支付页面点击左上角“返回”按钮，或支付成功后“返回商户按钮”的事件
					window.cmbMerchantRetClick = function() {
						plus.nativeUI.showWaiting();
						setTimeout(function() {
							//支付成功，检查支付状态
							mui.getJSON(app.getHost() + 'mall/paysuccess', {
								token: token,
								order_id: order_id
							}, function(ret) {
								plus.nativeUI.closeWaiting();
								if (ret.status == 200) {
									if (pay_success_callback) {
										pay_success_callback(ret.data);
									} else {
										mui.alert('支付成功');
									}

								} else {
									//支付失败(异步提交失败)
									if (paytype == 0) {
										mui.getJSON(app.getHost() + 'mall/payfail', {
											token: token,
											order_id: order_id
										}, function() {});
									}
									mui.alert('支付失败');
								}
							});
						}, 2000);
					}
				} else {

					//订单提交成功
					plus.payment.request(app.payChannels[payid], sign, function(result) {
						plus.nativeUI.showWaiting();
						setTimeout(function() {
							//支付成功，检查支付状态
							mui.getJSON(app.getHost() + 'mall/paysuccess', {
								token: token,
								order_id: order_id
							}, function(ret) {
								plus.nativeUI.closeWaiting();
								if (ret.status == 200) {
									if (pay_success_callback) {
										pay_success_callback(ret.data);
									} else {
										mui.alert('支付成功');
									}
								} else {
									//支付失败(异步提交失败)
									mui.alert('支付失败');
								}
							});
						}, 2000);
					}, function(e) {
						plus.nativeUI.closeWaiting();
						//支付失败(签名错误或取消了订单)
						if (paytype == 0) {
							mui.getJSON(app.getHost() + 'mall/payfail', {
								token: token,
								order_id: order_id
							}, function() {});
						}
						mui.alert('支付失败');
					});

				}
			} else {
				//订单提交失败(提交的数据不完整)
				mui.alert(res.info);
			}
		});

	}

	//调出活动支付通道进行支付
	app.playPay = function(payid, request_data, pay_success_callback) {
		//检测支付通道
		if (!(payid in app.payChannels)) {
			mui.alert('不支持此支付通道！');
			return;
		}

		var request_url = app.getHost() + 'mall/submitJoinMatch';

		var join_id = 0;
		var token = app.getStorage('token'); //用户token
		request_data.token = token;

		plus.nativeUI.showWaiting();
		//获取调出支付通道的支付签名
		mui.getJSON(request_url, request_data, function(res) {
			plus.nativeUI.closeWaiting();
			if (res.status == 200) {
				join_id = res.data.join_id;
				var sign = res.data.sign;
				//招行支付通道独立处理
				if (payid == 'cmb') {
					plus.nativeUI.showWaiting();
					//招行独立处理
					//创建招行支付WebView
					var ws = plus.webview.create(sign);
					ws.addEventListener('loaded', function() {
						ws.evalJS("plus.key.addEventListener('backbutton',function(){plus.webview.currentWebview().opener().evalJS('cmbMerchantRetClick()');plus.webview.currentWebview().close();},false);");
						plus.nativeUI.closeWaiting();
						ws.show();
					});

					//监听招行支付页面点击左上角“返回”按钮，或支付成功后“返回商户按钮”的事件
					window.cmbMerchantRetClick = function() {
						plus.nativeUI.showWaiting();
						setTimeout(function() {
							//支付成功，检查支付状态
							mui.getJSON(app.getHost() + 'mall/paySuccessMatch', {
								token: token,
								join_id: join_id
							}, function(ret) {
								plus.nativeUI.closeWaiting();
								if (ret.status == 200) {
									if (pay_success_callback) {
										pay_success_callback(ret.data);
									} else {
										mui.alert('支付成功');
									}

								} else {
									//支付失败(异步提交失败)
									mui.getJSON(app.getHost() + 'mall/payFailMatch', {
										token: token,
										join_id: join_id
									}, function(ree) {
										plus.nativeUI.closeWaiting();
										mui.alert('支付失败');
									});
								}
							});
						}, 2000);
					}
				} else {
					//订单提交成功
					plus.payment.request(app.payChannels[payid], sign, function(result) {
						plus.nativeUI.showWaiting();
						setTimeout(function() {
							//支付成功，检查支付状态
							mui.getJSON(app.getHost() + 'mall/paySuccessMatch', {
								token: token,
								join_id: join_id
							}, function(ret) {
								plus.nativeUI.closeWaiting();
								if (ret.status == 200) {
									if (pay_success_callback) {
										pay_success_callback(ret.data);
									} else {
										mui.alert('支付成功');
									}
								} else {
									//支付失败(异步提交失败)
									mui.alert('支付失败');
								}
							});
						}, 2000);
					}, function(e) {
						//支付失败(签名错误或取消了订单)
						mui.getJSON(app.getHost() + 'mall/payFailMatch', {
							token: token,
							join_id: join_id
						}, function(ree) {
							plus.nativeUI.closeWaiting();
							mui.alert('支付失败');
						});
					});

				}
			} else {
				//订单提交失败(提交的数据不完整)
				mui.alert(res.info);
			}
		});

	}

	//修改有沉浸式的页面的margin-top
	app.marginTop = function(e) {
		if (plus.navigator.isImmersedStatusbar() && e) {
			var eHeight = plus.navigator.getStatusbarHeight();
			e.style.marginTop = 44 + eHeight + 'px';
		}
	}

	//设置有沉浸式的页面的padding-top
	app.setPaddingTop = function(e) {
		if (plus.navigator.isImmersedStatusbar() && e) {
			var eHeight = plus.navigator.getStatusbarHeight();
			e.style.paddingTop = 44 + eHeight + 'px';
		}
	};

}(mui, window.app = {}));